"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    default: ()=>_default,
    BasicProperties: ()=>BasicProperties
});
const _index = require("../../index");
const _util = require("../util");
const _default = {
    title: 'Components/layer'
};
function SimpleButton({ x , y , width , height , label , onClick , fillStyle  }, ctx) {
    return [
        (0, _index.rect)({
            x,
            y,
            width,
            height,
            onClick,
            cursor: 'pointer',
            fillStyle
        }),
        (0, _index.text)({
            x: x + width / 2,
            y: y + height / 2,
            text: label,
            textAlign: 'center',
            textBaseline: 'middle',
            fillStyle: 'black'
        })
    ];
}
const simpleButton = (0, _index.defineComp)(SimpleButton);
function MyLayer({ y , name , onUpdateParent  }, ctx) {
    const [value, setValue] = (0, _index.crcState)(0);
    const renderCountRef = (0, _index.crcRef)(0);
    const renderCount = ++renderCountRef.current;
    return [
        (0, _index.text)({
            x: 10,
            y: y + 10,
            text: `Layer ${name} render count: ${renderCount}`,
            fillStyle: 'black'
        }),
        simpleButton({
            x: 10,
            y: y + 40,
            width: 100,
            height: 30,
            label: `Update ${name}`,
            onClick: ()=>{
                setValue(value + 1);
            },
            fillStyle: 'rgba(220, 220, 220, 1)'
        }),
        simpleButton({
            x: 10,
            y: y + 80,
            width: 100,
            height: 30,
            label: `Update parent of ${name}`,
            onClick: onUpdateParent,
            fillStyle: 'rgba(220, 220, 220, 1)'
        })
    ];
}
const myLayer = (0, _index.defineComp)(MyLayer);
function LayerDemo({ layerAWidth , layerAHeight , layerBWidth , layerBHeight  }, ctx) {
    const [value, setValue] = (0, _index.crcState)(0);
    const renderCountRef = (0, _index.crcRef)(0);
    const renderCount = ++renderCountRef.current;
    const handleUpdateParent = (0, _index.crcMemo)(()=>()=>{
            setValue(value + 1);
        }, []);
    return [
        (0, _index.text)({
            x: 10,
            y: 10,
            text: `Parent render count: ${renderCount}`,
            fillStyle: 'black'
        }),
        (0, _index.layer)({
            key: 'Layer A',
            width: layerAWidth,
            height: layerAHeight,
            render: myLayer({
                y: 30,
                name: 'A',
                onUpdateParent: handleUpdateParent
            })
        }),
        (0, _index.layer)({
            key: 'Layer B',
            width: layerBWidth,
            height: layerBHeight,
            render: myLayer({
                y: 200,
                name: 'B',
                onUpdateParent: handleUpdateParent
            })
        })
    ];
}
const layerDemo = (0, _index.defineComp)(LayerDemo);
const template = (0, _util.createTemplate)(layerDemo);
const BasicProperties = template({
    layerAWidth: 500,
    layerAHeight: 500,
    layerBWidth: 500,
    layerBHeight: 500
});

//# sourceMappingURL=layer.stories.js.map